#include <iostream>
#ifdef MUTEX
pthread_mutex_t lock = PTHREAD_MUTEX_INITIALIZER;
#endif
#ifdef SPIN
pthread_spinlock_t lock;
#endif
int Sum = 2086;
void* MySallary(void *args) {
    for (int i = 0; i < 1000000; i++){
#ifdef MUTEX
        pthread_mutex_lock(&lock);
#endif
#ifdef SPIN
        pthread_spin_lock(&lock);
#endif
        Sum++;
#ifdef SPIN
        pthread_spin_unlock(&lock);
#endif
#ifdef MUTEX
        pthread_mutex_unlock(&lock);
#endif
    }
    return NULL;
}

void* MyShopping(void *args) {
    for (int i = 0; i < 1000000; i++){
#ifdef MUTEX
        pthread_mutex_lock(&lock);
#endif
#ifdef SPIN
        pthread_spin_lock(&lock);
#endif
        Sum--;
#ifdef SPIN
        pthread_spin_unlock(&lock);
#endif
#ifdef MUTEX
        pthread_mutex_unlock(&lock);
#endif
      }
    return NULL;
}

int main() {
    pthread_t th1, th2;
#ifdef SPIN
    pthread_spin_init(&lock, 0);
#endif
    pthread_create(&th1, NULL, MySallary, NULL);
    pthread_create(&th2, NULL, MyShopping, NULL);
    pthread_join(th1, NULL);
    pthread_join(th2, NULL);
#ifdef MUTEX
    delete &lock;
#endif
#ifdef SPIN
    pthread_spin_destroy(&lock);
#endif
    std::cout << "Sum: " << Sum;
    return 0;
}
